<?php
/*
Plugin Name: Post links 
Version: 0.2.0
Plugin URI: http://labs.dagensskiva.com/
Author URI: http://henrikmelin.se/
Description:  Add (any number of) links to a post. Use &lt;?php post_links(); ?&gt; in your template to see them.
Author: Henrik Melin

	USAGE:
	
	In the Admin section a Link section will appear on the Write/Edit page, normally underneath
	the Upload section.

	The template function works as follows:
	
	<?php post_links(); ?> produced as dl/dt/dd list
	<?php post_links('dl'); ?> produced as dl/dt/dd list
	<?php post_links('ul'); ?> produced as ul/li list
	
	Alternatively, the html can be stored in a variable:

	<?php $links = get_post_links(); ?> returns a dl/dt/dd list

	For more information, see http://labs.dagensskiva.com/plugins/post-links/	
	
	LICENCE:

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
 
// Link fields
$lfds = array('url', 'title', 'description');
// This prefixes the custom fields and js functions.
$cfpx = 'dsc_link_';

/*
**  p2m_admin_build_divs ( )
**
**  This function is called by a hook and interates through our custom fiels and generates
**  the html and javascript code for each of them.
**
*/
function p2m_link_build_ui() {
    global $wpdb, $lfds, $cfpx;
        
    // The names of the post pages changed in WP v.2.1 - note that this bit broke in upgrading from 2.0 to 2.1
    if (preg_match("/post\.php/", $_SERVER['PHP_SELF']) || preg_match("/post-new\.php/", $_SERVER['PHP_SELF'])) {
	?>
	<!-- Externa lankar -->
	<div class="dbx-b-ox-wrapper">
	<fieldset id="<?php echo $cfpx; ?>box_div" class="dbx-box">
		<div class="dbx-h-andle-wrapper">
			<h3 class="dbx-handle"><?php _e('Links', 'post-links'); ?></h3>
		</div>
		<div class="dbx-c-ontent-wrapper">
			<div class="dbx-content">
				<span id="<?php echo $cfpx; ?>div"> 		
				<?php
					// Get the html for links stored in db
					echo p2m_link_html(0);
					for ($i=1; $i < p2m_get_nbr_links(); $i++) echo p2m_link_html($i);
				?>
				</span>
					<div style="margin-top: 5px; clear: left;">
						<input type="button" value="<?php _e('Add new link', 'post-links'); ?>" onClick="<?php echo $cfpx; ?>create_new();">
						<input name="save" type="submit" value="<?php _e('Save and continue editing', 'post-links'); ?>" />
					</div>
			</div>
			</div>
		</fieldset>
	</div>

	<script language="JavaScript" type="text/javascript">
		var theirbox = $('postexcerpt');
		var ourbox = $('<?php echo $cfpx; ?>box_div');
		theirbox.parentNode.insertBefore(ourbox, theirbox);

		function <?php echo $cfpx; ?>create_new ( ) {
			var nbr_links = <?php echo $cfpx; ?>nbr_links();
			// Save the values in the link form
			var values = Array();
			for (var i=0; i < nbr_links ; i++) {
<?php foreach ($lfds as $field) echo "\t\t\t\tvalues['${cfpx}${field}_' + i] = \$(('${cfpx}${field}_' + i)).value; \n"; ?>
			}
			var html = "<?php echo addcslashes(addslashes(p2m_link_html(8888)), "\n\r"); ?>";
			html = html.replace(/8888/g, (nbr_links));
			if ((nbr_links & 1)) html = html.replace('ffffff', 'eeeeee'); 
			// Gotta change this to insert() if we move to Prototype 1.6
			new Insertion.Bottom($('<?php echo $cfpx; ?>div'), html);
			// Restore the values in the link form
			for (var i = 0; i < nbr_links; i++) {
<?php foreach ($lfds as $field) echo "\t\t\t\t\$(('${cfpx}${field}_' + i)).value = values['${cfpx}${field}_' + i]; \n"; ?>
			}

		}
		function <?php echo $cfpx; ?>delete (field_id) {
			link_nbr = <?php echo $cfpx; ?>nbr_links() - 1;
			for (var i = parseFloat(field_id); i < link_nbr; i++ ) {
				if ($('<?php echo $cfpx; ?>title_' + (i + 1))) {
<?php foreach ($lfds as $field) echo "\t\t\t\t\t\$(('${cfpx}${field}_' + i)).value = \$(('${cfpx}${field}_' + (i + 1))).value; \n"; ?>
				}
			}
			$('<?php echo $cfpx; ?>external_' + link_nbr).remove(); 
		}
		function <?php echo $cfpx; ?>nbr_links() {
			var block = $('<?php echo $cfpx; ?>box_div');
			var fieldsets = block.getElementsByTagName("input");
		 	return (parseFloat(fieldsets.length)-2) / 5;
		}
		function <?php echo $cfpx; ?>move_up(field_id) {
			if (field_id > 0) {
<?php foreach ($lfds as $field) echo "\t\t\t\t${cfpx}swap('${cfpx}${field}_' + field_id, '${cfpx}${field}_' + (field_id - 1)); \n"; ?>
			}
		}
		function <?php echo $cfpx; ?>move_down(field_id) {
			if (field_id < <?php echo $cfpx; ?>nbr_links()) {
<?php foreach ($lfds as $field) echo "\t\t\t\t${cfpx}swap('${cfpx}${field}_' + field_id, '${cfpx}${field}_' + (field_id + 1)); \n"; ?>
			}		
		}
		function <?php echo $cfpx; ?>swap(id1, id2) {		
			var var1 = $(id1).value;
			var var2 = $(id2).value;
			$(id1).value = var2;
			$(id2).value = var1;		
		}
	</script>
	<?php
	} // end if - is this an edit or create post page
}

/*
**		p2m_link_html
**
*/
function p2m_link_html ($nbr) {
	global $cfpx;
	$post_id = $_GET['post'];
	$color   = (!($nbr & 1)) ? 'ffffff' : 'eeeeee'; 
	$title = stripslashes(get_post_meta($post_id, $cfpx . 'title_'.$nbr, true));
	$url = get_post_meta($post_id, $cfpx . 'url_'.$nbr, true);
	$description = stripslashes(get_post_meta($post_id, $cfpx . 'description_'.$nbr, true));	
	$html = '
			<div id="'.$cfpx.'external_'.$nbr.'" style="background: #'.$color.'; padding: .2em 0px; border: 0px;">
				<div style="float: right; width: 100px; margin-right: 5px;">
					<input type="button" value ="'.__('Move up', 'post-links').'" onclick="'.$cfpx.'move_up('.$nbr.');" style="width: 100px;" />
					<input type="button" value ="'.__('Move down', 'post-links').'" onclick="'.$cfpx.'move_down('.$nbr.');" style="width: 100px;" />
					<input type="button" value ="'.__('Delete', 'post-links').'" onclick="'.$cfpx.'delete('.$nbr.');" style="width: 100px;" />
				</div>
				<div style="clear: left; margin-right: 105px;">
					<div>
						<label for="'.$cfpx.'url_'.$nbr.'" style="text-align: right; width: 15%; display: block; float: left; margin-right: 1%;"><strong>'.__('URL', 'post-links').'</strong></label>
						<input type="text" name="'.$cfpx.'url_'.$nbr.'" id="'.$cfpx.'url_'.$nbr.'"  value="'. $url .'" style="width: 75%;" />
					</div>
					<div>
						<label for="'.$cfpx.'title_'.$nbr.'" style="text-align: right; width: 15%; display: block; float: left; margin-right: 1%;"><strong>'.__('Title', 'post-links').'</strong></label>
						<input type="text" name="'.$cfpx.'title_'.$nbr.'" id="'.$cfpx.'title_'.$nbr.'" value="'. $title .'" style="width: 75%" />
					</div>
					<div>
						<label for="'.$cfpx.'description_'.$nbr.'" style="text-align: right; width: 15%; display: block; float: left; margin-right: 1%;"><strong>'.__('Description', 'post-links').'</strong></label>
						<textarea name="'.$cfpx.'description_'.$nbr.'" id="'.$cfpx.'description_'.$nbr.'" style="width: 75%;" cols="1">' . $description . '</textarea>
					</div>
				</div>
			</div>';
	return $html;
}

/*
**		p2m_get_nbr_links ()
**
*/
function p2m_get_nbr_links($post = '') {
	global $post, $cfpx, $lfds;
	$post_id = ( $_GET['post'] ) ? $_GET['post'] : $post->ID;
	$nbr  = 0;
	while (get_post_meta($post_id, $cfpx . $lfds[0] . '_' . $nbr, true)) $nbr++;
	return $nbr;
}

/*
**		p2m_save_links ( )
**
*/
function p2m_save_links () {
	global $lfds, $cfpx;
	$post_id = $_POST['post_ID'];
	$nbr = 0;
	while ($_POST[$cfpx . $lfds[0] . '_' . $nbr] != '') {
		foreach ($lfds as $field) {
			$key = $cfpx . $field . '_' . $nbr;
			$value = stripslashes($_POST[$key]);
			if (!add_post_meta($post_id, $key, $value, true)) 
				update_post_meta($post_id, $key, $value);
		}
		$nbr++;
	}
}

/*
**		post_links ( )
**		get_post_links ( )
**
*/
function post_links($args = '') { echo get_post_links($args); }
function get_post_links($args = '') {
	global $post, $cfpx;
	
	// Parse args
	$defaults = array('format' => 'dl', 'div' => '', 'title' => '');
	$args = wp_parse_args($args, $defaults);	
	if (get_post_meta($post->ID, $cfpx . 'url_0' , true)) {
		$html = '';
		if ($div = $args['div']) $html .= "<div id='$div'>\n";
		if ($title = $args['title']) $html .= "<h3>$title</h3>\n";
		$html .= "<" . $args['format'] . " class=\"\">\n";
		for ($i = 0; $i < p2m_get_nbr_links(); $i++) {
			$url = wptexturize(get_post_meta($post->ID, $cfpx . 'url_' . $i, true));
			$title = wptexturize(get_post_meta($post->ID, $cfpx . 'title_' . $i, true));
			$description = wptexturize(get_post_meta($post->ID, $cfpx . 'description_' . $i, true));
//			$description = stripslashes($description);
			if (!$title) $title = $url;
			if ($args['format'] == 'dl') {
				$html .= "<dt><a href=\"$url\">$title</a></dt>\n";
				$html .= "<dd>$description</dd>\n";
			}
			else if ($args['format'] == 'ul') {
				$html .= "<li><p><a href=\"$url\">$title</a></p>\n";
				if (description) $html .= "<p>$description</p>";
				$html .= "</li>\n";		
			}
		}
		$html .= "</" . $args['format'] . ">";
		if ($div = $args['div']) $html .= '</div>';
		return $html;
	}
}


/*
**		p2m_translate ( )
**
*/
function p2m_translate(){
    // Load a language
	load_plugin_textdomain('post-links', PLUGINDIR . '/' . dirname(plugin_basename (__FILE__)) );
}

/*
**  These are the WP hooks.
*/
add_action('init', 'p2m_translate'); 
add_action('admin_footer', 'p2m_link_build_ui'); 
add_action('save_post', 'p2m_save_links');
add_action('publish_post', 'p2m_save_links');

?>